rem TSYSINFO.OPL
rem
rem Copyright (c) 1997-2000 Symbian Ltd. All rights reserved.
rem
rem Tests SYSTINFO.OPX against ER5

include "const.oph"
include "systinfo.oxh"

const KEmptyOwner&=6
const KBlankOwner&=2941
const KStandardDir$="c:\Documents\"
const KBookmark$="c:\Documents\"
const KTestFile$="c:\Tester.tst"

proc TSysInfo:
    local failed&
    failed&=failed& or TOwner&:
    failed&=failed& or TVisibility&:
		failed&=failed& or TBookmark&:
    failed&=failed& or TUniqueFilename&:
    failed&=failed& or TIsPathVisible&:
    failed&=failed& or TKeyClickLoud&:
    failed&=failed& or TKeyClickOverridden&:
    failed&=failed& or TSoundDriverEnabled&:
    failed&=failed& or TLinkEnableWithOptions&:
    if failed&
        print "*****SOME TESTS FAILED*****"
    else
        print "*****ALL TESTS PASSED!!******"
    endif
    get   	
endp

proc TOwner&:
    local a$(KMaxStringLen%)
    local i&
    local checksum&
    a$=SIOwner$:
    i&=1
    while i&<= len(a$)
        checksum&=checksum&+asc(mid$(a$,i&,1))
        i&=i&+1
    endwh
    if (checksum&<>KEmptyOwner&) and (checksum&<>KBlankOwner&)
        print "*** Owner Test failed: Checksum was",checksum&
        print "                       returned SIOwner$ was: ",a$
        return -1
    else
        Print "Owner:",a$
        return 0
    endif
endp

proc TVisibility&:
    local s&
    local h&
    s&=SISystemVisible&:
    h&=SIHiddenVisible&:
    if s&=0 and h&=0
        print "System dir visible:",s&,"Show hidden files:",h&
        return 0
    else
        print "*** Visibility test failed: System dir visible:",s&;", Show hidden files:",h& 
        print "                 Should be: System dir visible:",0;", Show hidden files:",0
        return -1
    endif
endp

proc TBookmark&:
    local b$(KMaxStringLen%)
    local s$(KMaxStringLen%)
    
    b$=SIBookmark$:
    s$=SIStandardFolder$:
    if b$=KBookmark$ and ( s$=KStandardDir$ or s$=KBookmark$)
        print "Bookmark:",b$;", Standard Folder:",s$
        return 0
    else
        print "*** Bookmark test failed: Bookmark:",b$;" ,Standard Folder:",s$
        print "               Should be: Bookmark:",KBookmark$;", Standard Folder:",KStandardDir$
        return -1
    endif
endp

proc TUniqueFilename&:
    local h%
    local a$(KMaxStringLen%)
    local expectedFilename$(KMaxStringLen%)
    local dot&
    dot&=loc(KTestFile$,".")
    expectedFilename$=left$(KTestFile$,dot&-1)+"(01)"+mid$(KTestFile$,dot&,255)
    ioopen(h%,KTestFile$,2)
    ioclose(h%)
    a$=SIUniqueFilename$:(KTestFile$)
    delete KTestFile$
    if a$<>expectedFilename$
        print "*** Unique Filename test failed: Unique Filename:",a$
        return -1
    else
        print "Unique Filename:",a$
        return 0
    endif
endp

proc TIsPathVisible&:
	print "Path Visible:";
    print SIIsPathVisible&:("c:\Documents\Test")
	return 0
endp

proc TMemory&:
	local TotalRamInBytes&
	local TotalRomInBytes&
	local MaxFreeRamInBytes&
	local FreeRam&
	local InternalDiskRamInBytes&

	SIMemory:(TotalRamInBytes&,TotalRomInBytes&,MaxFreeRamInBytes&,FreeRam&,InternalDiskRamInBytes&)
	print "Total Ram:",TotalRamInBytes&
	print "Total Rom:",TotalRomInBytes&
	print "Max Free Ram:",MaxFreeRamInBytes&
	print "Free Ram:",FreeRam&
	print "Internal Ram:",InternalDiskRamInBytes&
	return 0
endp

proc TKeyClickLoud&:
	print "Key Click Loud:",SIKeyClickLoud%:
	return 0
endp

proc TKeyClickOverridden&:
	print "Key Click Overridden:",SIKeyClickOverridden%:
	return 0
endp

proc TSoundDriverEnabled&:
	print "Sound driver enabled:",SISoundDriverEnabled%:
	return 0
endp

proc TDisplaySize&:
	local displayWidthInPixels&
	local displayHeightInPixels&
	local xYInputWidthInPixels&
	local xYInputHeightInPixels&
	local physicalScreenWidth&
	local physicalScreenHeight&
	SIDisplaySize:(displayWidthInPixels&, displayHeightInPixels&, xYInputWidthInPixels&, xYInputHeightInPixels&, physicalScreenWidth&, physicalScreenHeight&)
	print "Display Width In Pixels:", displayWidthInPixels& 
	print "Display Height In Pixels:", displayHeightInPixels&
	print "XY Input Width In Pixels:",  xYInputWidthInPixels& 
	print "XY Input Height In Pixels:", xYInputHeightInPixels&
	print "Physical Screen Width:", physicalScreenWidth&  
	print "Physical Screen Height:", physicalScreenHeight& 
endp

proc TLinkEnableWithOptions&:
local err%

	err%=_ShowLinkConfig:
	
	TryCable::
	ONERR CableErr::
	PRINT "Enabling remote link to Cable/115200...."
	SIRemoteLinkEnableWithOptions:(KLinkTypeCable%,KLinkBps115200%)
	err%=_ShowLinkConfig:
	PRINT "....please check it from System and then press any key back here. "
	GET
	SIRemoteLinkDisable:
	GOTO TryIr::
	CableErr::
	PRINT "*FAILED*"
	err%=-1

	ONERR OFF
	TryIr::
	ONERR IrErr::
	PRINT "Enabling remote link to IrDA/57600...."
	SIRemoteLinkEnableWithOptions:(KLinkTypeIrDA%,KLinkBps57600%)
	err%=_ShowLinkConfig:
	PRINT "....please check it from System and then press any key back here. "
	GET
	SIRemoteLinkDisable:
	GOTO End::
	IrErr::
	PRINT "*FAILED*"
	err%=-1

	End::
	RETURN err%
endp

proc _ShowLinkConfig:
local baud%,type%

	ONERR LinkNotOn::
	PRINT "Getting current link config (SIRemoteLinkConfig):"
	SIRemoteLinkConfig:(type%,baud%)
	PRINT "Type id =",type%,", Baud id =",baud%
	PRINT "type%=0 for unknown, type%=1 for cable, type%=2 for IrDA"
	PRINT "baud%=0 for unknown, baud%=1 for 9600, baud%=2 for 19200"
	PRINT "baud%=3 for 38400, baud%=4 for 57600, baud%=5 for 115200"
	GOTO End::
	LinkNotOn::
	PRINT "*FAILED* -",ERR$(ERR)
	return -1
	
	End::
	return 0
endp